<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/TypeAnalysis/Visitor.hh.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/TypeAnalysis/Visitor.hh</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/TypeAnalysis/Visitor.hh</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="comment">//</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="comment">// Copyright (C) 2005 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="comment">// All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="comment">// Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="comment">// see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="comment">//</span></span>
<a id="line7"></a><span class="lineno"> 7</span><span class="line">#ifndef Synopsis_TypeAnalysis_Visitor_hh_</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line">#define Synopsis_TypeAnalysis_Visitor_hh_</span>
<a id="line9"></a><span class="lineno"> 9</span>
<a id="line10"></a><span class="lineno">10</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis.html" title="namespace Synopsis">Synopsis</a></span>
<a id="line11"></a><span class="lineno">11</span><span class="line">{</span>
<a id="line12"></a><span class="lineno">12</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis/TypeAnalysis.html" title="namespace Synopsis::TypeAnalysis">TypeAnalysis</a></span>
<a id="line13"></a><span class="lineno">13</span><span class="line">{</span>
<a id="line14"></a><span class="lineno">14</span>
<a id="line15"></a><span class="lineno">15</span><span class="line">class Type;</span>
<a id="line16"></a><span class="lineno">16</span><span class="line">class BuiltinType;</span>
<a id="line17"></a><span class="lineno">17</span><span class="line">class Enum;</span>
<a id="line18"></a><span class="lineno">18</span><span class="line">class Class;</span>
<a id="line19"></a><span class="lineno">19</span><span class="line">class Union;</span>
<a id="line20"></a><span class="lineno">20</span><span class="line">class CVType;</span>
<a id="line21"></a><span class="lineno">21</span><span class="line">class Pointer;</span>
<a id="line22"></a><span class="lineno">22</span><span class="line">class Reference;</span>
<a id="line23"></a><span class="lineno">23</span><span class="line">class Array;</span>
<a id="line24"></a><span class="lineno">24</span><span class="line">class Function;</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">class PointerToMember;</span>
<a id="line26"></a><span class="lineno">26</span>
<a id="line27"></a><span class="lineno">27</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html" title="class Synopsis::TypeAnalysis::Visitor">Visitor</a></span>
<a id="line28"></a><span class="lineno">28</span><span class="line">{</span>
<a id="line29"></a><span class="lineno">29</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line30"></a><span class="lineno">30</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#_tVisitor_l_r" title="member function Synopsis::TypeAnalysis::Visitor::~Visitor()">~Visitor</a>() {}</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">  <span class="comment">// FIXME: may these use const arguments ?</span></span>
<a id="line32"></a><span class="lineno">32</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lType_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(Type*)">visit</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Type.html" title="class Synopsis::TypeAnalysis::Type">Type</a> *) = 0;</span>
<a id="line33"></a><span class="lineno">33</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lBuiltinType_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(BuiltinType*)">visit</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/BuiltinType.html" title="class Synopsis::TypeAnalysis::BuiltinType">BuiltinType</a> *) = 0;</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lEnum_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(Enum*)">visit</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Enum.html" title="class Synopsis::TypeAnalysis::Enum">Enum</a> *) = 0;</span>
<a id="line35"></a><span class="lineno">35</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lClass_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(Class*)">visit</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Class.html" title="class Synopsis::TypeAnalysis::Class">Class</a> *) = 0;</span>
<a id="line36"></a><span class="lineno">36</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lUnion_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(Union*)">visit</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Union.html" title="class Synopsis::TypeAnalysis::Union">Union</a> *) = 0;</span>
<a id="line37"></a><span class="lineno">37</span>
<a id="line38"></a><span class="lineno">38</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lCVType_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(CVType*)">visit</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/CVType.html" title="class Synopsis::TypeAnalysis::CVType">CVType</a> *) = 0;</span>
<a id="line39"></a><span class="lineno">39</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lPointer_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(Pointer*)">visit</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Pointer.html" title="class Synopsis::TypeAnalysis::Pointer">Pointer</a> *) = 0;</span>
<a id="line40"></a><span class="lineno">40</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lReference_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(Reference*)">visit</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Reference.html" title="class Synopsis::TypeAnalysis::Reference">Reference</a> *) = 0;</span>
<a id="line41"></a><span class="lineno">41</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lArray_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(Array*)">visit</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Array.html" title="class Synopsis::TypeAnalysis::Array">Array</a> *) = 0;</span>
<a id="line42"></a><span class="lineno">42</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lFunction_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(Function*)">visit</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/Function.html" title="class Synopsis::TypeAnalysis::Function">Function</a> *) = 0;</span>
<a id="line43"></a><span class="lineno">43</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/Visitor.html#visit_lPointerToMember_S_r" title="member function Synopsis::TypeAnalysis::Visitor::visit(PointerToMember*)">visit</a>(<a href="../../../Scopes/Synopsis/TypeAnalysis/PointerToMember.html" title="class Synopsis::TypeAnalysis::PointerToMember">PointerToMember</a> *) = 0;</span>
<a id="line44"></a><span class="lineno">44</span><span class="line">};</span>
<a id="line45"></a><span class="lineno">45</span>
<a id="line46"></a><span class="lineno">46</span><span class="line">}</span>
<a id="line47"></a><span class="lineno">47</span><span class="line">}</span>
<a id="line48"></a><span class="lineno">48</span>
<a id="line49"></a><span class="lineno">49</span><span class="line">#endif</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:28:04 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
